import { Context, PublicKey } from '@metaplex-foundation/umi';
import { DasApiAsset, DasApiInterface, GetAssetProofRpcResponse } from '@metaplex-foundation/digital-asset-standard-api';
import { MetadataArgs } from './generated';
export declare type AssetWithProof = {
    leafOwner: PublicKey;
    leafDelegate: PublicKey;
    merkleTree: PublicKey;
    root: Uint8Array;
    dataHash: Uint8Array;
    creatorHash: Uint8Array;
    nonce: number;
    index: number;
    proof: PublicKey[];
    metadata: MetadataArgs;
    rpcAsset: DasApiAsset;
    rpcAssetProof: GetAssetProofRpcResponse;
};
declare type GetAssetWithProofOptions = {
    truncateCanopy?: boolean;
};
export declare const getAssetWithProof: (context: Pick<Context, 'rpc'> & {
    rpc: DasApiInterface;
}, assetId: PublicKey, options?: GetAssetWithProofOptions | undefined) => Promise<AssetWithProof>;
export {};
