"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCurrentRoot = exports.getConcurrentMerkleTreeSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const changeLog_1 = require("./changeLog");
const path_1 = require("./path");
const getConcurrentMerkleTreeSerializer = (maxDepth, maxBufferSize) => (0, serializers_1.struct)([
    ['sequenceNumber', (0, serializers_1.u64)()],
    ['activeIndex', (0, serializers_1.u64)()],
    ['bufferSize', (0, serializers_1.u64)()],
    [
        'changeLogs',
        (0, serializers_1.array)((0, changeLog_1.getChangeLogSerializer)(maxDepth), { size: maxBufferSize }),
    ],
    ['rightMostPath', (0, path_1.getPathSerializer)(maxDepth)],
]);
exports.getConcurrentMerkleTreeSerializer = getConcurrentMerkleTreeSerializer;
const getCurrentRoot = (tree) => (0, umi_1.publicKeyBytes)(tree.changeLogs[Number(tree.activeIndex)].root);
exports.getCurrentRoot = getCurrentRoot;
//# sourceMappingURL=concurrentMerkleTree.js.map