"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPathSerializer = void 0;
const serializers_1 = require("@metaplex-foundation/umi/serializers");
function getPathSerializer(maxDepth) {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['proof', (0, serializers_1.array)((0, serializers_1.publicKey)(), { size: maxDepth })],
        ['leaf', (0, serializers_1.publicKey)()],
        ['index', (0, serializers_1.u32)()],
        ['padding', (0, serializers_1.u32)()],
    ], { description: 'Path' }), (path) => ({ ...path, padding: 0 }), (pathWithPadding) => {
        const { padding, ...path } = pathWithPadding;
        return path;
    });
}
exports.getPathSerializer = getPathSerializer;
//# sourceMappingURL=path.js.map